;FILE: M1T1.ASM
;
;THIS PROGRAM TRANSMITS THE HEX VALUE AA REPETITIVELY ACCROSS THE SERIAL PORT
;OF A MCS-51 IN MODE 1 USING TIMER 1 AT A RATE OF 2400 BAUD
;
;DETAILS:
;
;MODE 1: TEN BITS ARE TRANSMITTED THROUGH TXD OR RECEIVED THROUGH RXD
;WITH THE START BIT FIRST (0), 8 DATA BITS WITH THE LEAST SIGNIFICANT BIT
;FIRST, AND A STOP BIT (1).  ON RECEIVE, THE STOP BIT GOES INTO RB8 IN
;SPECIAL FUNCTION REGISTER SCON.  THE BAUD RATE IS VARIABLE.
;
;
	PCON EQU 87H

	ORG 00H
	JMP MAIN
MAIN:   MOV SCON,#40H             ;SET SERIAL PORT FOR MODE 1 OPERATION
	MOV PCON,#80H		  ;SET DOUBLE BAUD RATE BIT
        MOV TMOD,#20H             ;SET TIMER 1 TO AUTO RELOAD
        MOV TH1,#0DDH             ;LOAD RELOAD VALUE FOR 2400 BAUD AT 16MHZ
        MOV TCON,#40H             ;START TIMER 1
        CLR TI
LOOP:   MOV SBUF,#053H            ;TRANSMIT AA HEX OUT THE TXD LINE
        JNB TI,$                  ;WAIT UNTIL TRANSMISSION COMPLETED
        CLR TI                    ;READY TO TRANSMIT ANOTHER
        JMP LOOP                  ;DO IT ALL OVER AGAIN
        END
