$nomod51	symbols	debug	nolist
$INCLUDE(\i\rg51fb.pdf)
$INCLUDE(charname.a51)
$list
;
;	CONSOLE I/O ROUTINES AND DRIVERS:
;	======= === ======== === =======
; S_INIT - Initializes Serial port.
;
; C_IN   - waits for character from serial port. Returns it in A.
; C_OUT  - sends character in A.
; C_STS  - console status. if char RXD, C=1, A=char, else C=0.
; STROUT - Sends in-line character string to console. String is terminated
;	by last character's MSB set.  Hence, can only handle 7 bit ASCII.
;
;********************************************
;Baud rate manually set to 110 baud
;  using timer 1, by running timer 1 as a 16 bit timer, and using
;  Timer 1 interrupt to reload the timer.
;This version uses 1x baud rate
;********************************************
CODE_SEG	segment	code
public	S_init,C_IN,C_OUT,STROUT
;public	baudload
;
cseg	at	timer1
T1Int:
	mov	th1,#high baudload
	mov	tl1,#low baudload
	reti
;
	rseg	CODE_SEG
;
;BaudLoad	equ	0FEEBH	; 12 MHz, 110 baud, from handbook
;BaudLoad	equ	0FEE3H	; 12 MHz, 110 baud, correct value
;BaudLoad	equ	0FE84H	; 16 MHz, 110 baud
;BaudLoad	equ	0FEFAH	; 11.0592 MHz, 110 baud
;BaudLoad	equ	0FEA2H	; 14.7456 MHz, 110 baud
BaudLoad	equ	0FE4BH	; 18.4320 MHz, 110 baud

;
S_INIT:
	CLR	TR1
	MOV	SCON,#11011010B	;TI set indicates transmitter ready.
				; mode 3(9 bit),REN, bit 9 = 1 (stop bit).
	MOV	TMOD,#00010001B	;Timer 1 is set to 16 bit timer mode.
	ANL	PCON,#not SMOD	; Set SMOD to single baud rate
	mov	th1,#high BaudLoad
	mov	tl1,#low baudload
	setb	et1
	setb	tr1
	setb	ea
	ret
;
;=======
;
C_IN:
;	Console character input routine.
;	Waits for next input from console device and returns with character
;	code in accumulator.
;
        JNB     RI,$            ;Wait until character received.
        MOV     A,SBUF          ;Read input character.
	CLR	RI		;Clear reception flag.
	ret			;
;
;=======
;
C_OUT:
;	Console character output routine.
;	Outputs character received in accumulator to console output device.
;
        JNB     TI,$            ;Wait until transmission completed.
        CLR     TI              ;Clear interrupt flag.
	MOV	SBUF,A		;Write out character.
	RET
;
;=======
;
;Console Status
;
; Returns C=0 if no character is ready
; if character ready, returns C=1 and character in A
; Note: Serial input status can be checked by RI bit, also.
;
C_STS:	MOV	C,RI
	JNC	CNTRET		;Poll whether character has been typed.
	CALL	C_IN
CNTRET:	RET
;
;=======
;
;STROUT
;	Copy in-line character string to console output device.
;	uses:	DPTR,ACC
;
STROUT:	POP	DPH		;get in-line string address from stack
	POP	DPL
STRO_1:	CLR	A
	MOVC	A,@A+DPTR	;Read next byte.
	INC	DPTR		;Bump pointer.
	JBC	ACC.7,STRO_2	;Escape after last character.
	CALL	C_OUT		;Output character.
	SJMP	STRO_1		;Loop until done.
;
STRO_2:	CALL	C_OUT		;Output character.
	CLR	A
	JMP	@A+DPTR		;Return to program.
;
	end
